#include <stdio.h>
#include <stdlib.h>
#include "wish.h"
#include <nSystem.h>

int nplayers;
int *tunnel;
int inter_x, inter_y;

nMonitor out;
nCondition *empty; /* arreglo de nplayers condiciones */
int waiting1, waiting2; /* cuentan los que esperan en 1 y en 2 */

#define GORDO 10

tun_enter1(nMonitor mon, int item) {
    nEnter(mon);
    waiting1++;
    while(tunnel[0] != 0) 
	nWaitConditionPrior(empty[0], 2); /* Espero vacio de 2 */

    tunnel[0] = item;
    waiting1--;

    nExit(mon);
}

tun_enter2(nMonitor mon, int item) {
    nEnter(mon);
    waiting2++;
    while(tunnel[0] != 0) 
	nWaitConditionPrior(empty[0], 1); /* Espero vacio de 1 */

    tunnel[0] = item;
    waiting2--;

    nExit(mon);
}

tun_move(nMonitor mon, int i, int prior) {
    nEnter(mon);
    while(i < nplayers && tunnel[i+1] != 0) {
	nWaitCondition(empty[i+1]); /* Esta es sin prioridad */
    }

    if(i < nplayers) { tunnel[i+1] = tunnel[i];
	move_w(tunnel[i], GORDO, 0); 
    } else delete_w(tunnel[i]);
    tunnel[i] = 0;
    nSignalConditionPrior(empty[i], prior); /* Aviso vacio de mi numero */
    nExit(mon);
}
 

/* Deberia ser un auto con un parametro de "entry" */
int auto2(int x, int y) {
    int item;
    int i;

    item = create_obj_w(x, y, GORDO, "oval", "red");
    tun_enter2(out, item);
    coords_w(item, inter_x, inter_y, GORDO);

    for(i=0; i < nplayers; i++) {
	tun_move(out, i, 2);
    }

    tun_move(out, i, 2);
    return 0;
}

int auto1(int x, int y) {
    int item;
    int i;

    item = create_obj_w(x, y, GORDO, "oval", "green");
    tun_enter1(out, item);
    coords_w(item, inter_x, inter_y, GORDO);

    for(i=0; i < nplayers; i++) {
	tun_move(out, i, 1);
    }

    tun_move(out, i, 1);
    return 0;
}

nMain(int argc, char *argv[]) {
    int i, alive;
    int itxt1=0, itxt2=0;
    char s1[128], s2[128];
    int nautos, tot_autos=0;

    if(argc!=3)
      {
        fprintf(stderr, "Use: %s nautos largo\n", argv[0]);
        exit(1);
      }

    nautos=atoi(argv[1]);
    nplayers=atoi(argv[2]);

    nSetTimeSlice(1);

    out = nMakeMonitor();
    empty = (nCondition *)malloc((nplayers+1)*sizeof(nCondition));
    for(i=0; i <= nplayers; i++) 
	empty[i] = nMakeCondition(out);
    tunnel=(int *)malloc(nplayers+1);
    for(i=0; i <= nplayers; i++) 
	tunnel[i]=0;
    inter_x = 3*GORDO;
    inter_y = 3*GORDO;
    waiting1 = waiting2 = 0;

    init_w((nplayers+1)*GORDO+6*GORDO, 6*GORDO);

    create_obj_w(inter_x, inter_y, GORDO, "rectangle", "white");


   sleep(1); 

    while(tot_autos <= nautos) {
        /* usamos 120 contra 32 para mostrar que funciona */
	if((rand()>>24) < 120) {
	    tot_autos++;
	    nEmitTask(auto1, GORDO, 2*GORDO);
        }
	if((rand()>>24) < 32) {
	    tot_autos++;
	    nEmitTask(auto2, GORDO, 4*GORDO);
	}
        sprintf(s1, "cnt=%d", waiting1);
        sprintf(s2, "cnt=%d", waiting2);
    	if(itxt1 != 0) delete_w(itxt1);
    	if(itxt2 != 0) delete_w(itxt2);
        itxt1 = create_obj_w(3*GORDO, GORDO, GORDO, "text", s1);
        itxt2 = create_obj_w(3*GORDO, 5*GORDO+5, GORDO, "text", s2);
        nSleep(600);
    }

    close_w("Finish!", 2*GORDO, GORDO);
}
